Index: /documentation/user_manual/anuga_user_manual.tex
===================================================================
--- /documentation/user_manual/anuga_user_manual.tex	(revision 2716)
+++ /documentation/user_manual/anuga_user_manual.tex	(revision 2717)
@@ -189,5 +189,5 @@
 
 In outline, \file{bedslopephysical.py} performs the following steps:
-				   
+                   
 \begin{enumerate}
 
@@ -328,5 +328,5 @@
 
 The assignment of the friction quantity demonstrates another way
-we can use \code{set\_quantity} to set quantities---namely,
+we can use \method{set\_quantity} to set quantities---namely,
 assign them to a constant numerical value:
 
@@ -361,5 +361,5 @@
 (Although it is not necessary for this example, it may be useful to digress here
 and mention a variant to this requirement, which allows us to illustrate
-another way to use \code{set\_quantity}---namely, incorporating an expression
+another way to use \method{set\_quantity}---namely, incorporating an expression
 involving other quantities. Suppose, instead of setting a constant value
 for the stage, we wished
@@ -378,5 +378,5 @@
 
 The reader will probably appreciate that this capability to incorporate
-expressions into statements using \code{set\_quantity} greatly expands
+expressions into statements using \method{set\_quantity} greatly expands
 its power.)
 
@@ -473,8 +473,8 @@
 
 \begin{itemize}
-  \item{from a Windows command line} as in \code{python bedslopephysical.py}
+  \item{from a Windows command line} as in \file{python bedslopephysical.py}
   \item{within the Python IDLE environment}
   \item{within emacs}
-  \item{from a Linux command line} as in \code{python bedslopephysical.py}
+  \item{from a Linux command line} as in \file{python bedslopephysical.py}
 \end{itemize}
 
@@ -517,9 +517,9 @@
 
 The following discussion builds on the concepts introduced through
-the \code{bedslopephysical.py} example and introduces a second example,
-\code{run\_sydney\_smf.py}, that follows the same basic outline, but
+the \file{bedslopephysical.py} example and introduces a second example,
+\file{run\_sydney\_smf.py}, that follows the same basic outline, but
 incorporates more complex features and refers to a real-life
 scenario, rather than the artificial illustrative one used in
-\code{bedslopephysical.py}. The domain of interest surrounds the Sydney region,
+\file{bedslopephysical.py}. The domain of interest surrounds the Sydney region,
 and predominantly covers Sydney Harbour. A hypothetical tsunami wave is
 generated by a submarine mass failure situated on the edge of the
@@ -527,5 +527,5 @@
 
 \subsection{Overview}
-As in the case of \code{bedslopephysical.py}, the actions carried out by the
+As in the case of \file{bedslopephysical.py}, the actions carried out by the
 program can be organised according to this outline:
 
@@ -553,5 +553,5 @@
 \subsection{The Code}
 
-Here is the code for \code{run\_sydney\_smf.py}:
+Here is the code for \file{run\_sydney\_smf.py}:
 
 %\verbatiminput{"runsydneysmf.py"}
@@ -564,5 +564,5 @@
 
 One obvious way that the present example differs from
-\code{bedslopephysical.py} is in the use of a more complex method to create
+\file{bedslopephysical.py} is in the use of a more complex method to create
 the mesh. Instead of imposing a mesh structure on a rectangular
 grid, the technique used for this example involves building mesh
@@ -592,5 +592,5 @@
 Boundary tags are not restricted to \code{`left'}, \code{`right'},
 \code{`bottom'} and \code{`top'}, as in the case of
-\code{bedslopephysical.py}. Instead the user specifies a list of tags
+\file{bedslopephysical.py}. Instead the user specifies a list of tags
 appropriate to the configuration being modelled.
 
@@ -623,5 +623,5 @@
 
 The function used to implement this process is
-\code{create\_mesh\_from\_regions}. Its arguments include the
+\function{create\_mesh\_from\_regions}. Its arguments include the
 bounding polygon and its resolution, a list of boundary tags, and a
 list of pairs \code{[polygon, resolution]}, specifying the interior
@@ -629,5 +629,5 @@
 
 In practice, the details of the polygons used are read from a
-separate file \code{project.py}. The resulting mesh is output to a
+separate file \file{project.py}. The resulting mesh is output to a
 \emph{meshfile}\index{meshfile}. This term is used to describe a
 file of a specific format used to store the data specifying a mesh.
@@ -639,5 +639,5 @@
 \code{pmesh} assigns a name to the file by appending the extension
 \code{.msh} to the name specified in the input file
-\code{project.py}. This name is stored in the variable
+\file{project.py}. This name is stored in the variable
 \code{meshname}.
 
@@ -651,5 +651,5 @@
 
 are used to read in the specific polygons \code{project.harbour\_polygon\_2} and
-\code{botanybay\_polygon\_2} from \code{project.py} and assign a
+\code{botanybay\_polygon\_2} from \file{project.py} and assign a
 common resolution of 5000 to each. The statement
 
@@ -670,5 +670,5 @@
 
 is then used to create the mesh, taking the bounding polygon to be the polygon
-\code{diffpolygonall} specified in \code{project.py}. The
+\code{diffpolygonall} specified in \file{project.py}. The
 argument \code{boundary\_tags} assigns a dictionary, whose keys are the
 names of the boundary tags used for the bounding polygon---\code{`bottom'},
@@ -680,7 +680,7 @@
 \subsection{Initialising the Domain}
 
-As with \code{bedslopephysical.py}, once we have created the mesh, the next
+As with \file{bedslopephysical.py}, once we have created the mesh, the next
 step is to create the data structure \code{domain}. We did this for
-\code{bedslopephysical.py} by inputting lists of points and triangles and
+\file{bedslopephysical.py} by inputting lists of points and triangles and
 specifying the boundary tags directly. However, in the present case,
 we use a method that works directly with the meshfile
@@ -692,17 +692,17 @@
 \end{verbatim}}
 
-The function \code{pmesh\_to\_domain\_instance} converts a meshfile
+The function \function{pmesh\_to\_domain\_instance} converts a meshfile
 \code{meshname} into an instance of the data structure
-\code{domain}, allowing us to use methods like \code{set\_quantity}
+\code{domain}, allowing us to use methods like \method{set\_quantity}
 to set quantities and to apply other operations. (In principle, the
-second argument of \code{pmesh\_to\_domain\_instance} can be any
-subclass of \code{Domain}, but for applications involving the
+second argument of \function{pmesh\_to\_domain\_instance} can be any
+subclass of \class{Domain}, but for applications involving the
 shallow-water wave equation, the second argument of
-\code{pmesh\_to\_domain\_instance} can always be set simply to
-\code{Domain}.)
+\function{pmesh\_to\_domain\_instance} can always be set simply to
+\class{Domain}.)
 
 The following statements specify a basename and data directory, and
 identify quantities to be stored. For the first two, values are
-taken from \code{project.py}.
+taken from \file{project.py}.
 
 {\small \begin{verbatim}
@@ -715,8 +715,8 @@
 
 \subsection{Specifying the Quantities}
-Quantities for \code{run\_sydney\_smf.py} are set
-using similar methods to those in \code{bedslopephysical.py}. However,
+Quantities for \file{run\_sydney\_smf.py} are set
+using similar methods to those in \file{bedslopephysical.py}. However,
 in this case, many of the values are read from the auxiliary file
-\code{project.py} or, in the case of \code{elevation}, from an
+\file{project.py} or, in the case of \code{elevation}, from an
 ancillary points file.
 
@@ -727,6 +727,6 @@
 For the scenario we are modelling in this case, we use a callable
 object \code{tsunami\_source}, assigned by means of a function
-\code{slump\_tsunami}. This is similar to how we set elevation in
-\code{bedslopephysical.py} using a function---however, in this case the
+\function{slump\_tsunami}. This is similar to how we set elevation in
+\file{bedslopephysical.py} using a function---however, in this case the
 function is both more complex and more interesting.
 
@@ -739,5 +739,5 @@
 \subsubsection{Friction}
 
-We assign the friction exactly as we did for \code{bedslopephysical.py}:
+We assign the friction exactly as we did for \file{bedslopephysical.py}:
 
 {\small \begin{verbatim}
@@ -760,5 +760,5 @@
 are needed to prepare the file from which the data is taken. Two
 source files are used for this data---their names are specified in
-the file \code{project.py}, in the variables \code{coarsedemname}
+the file \file{project.py}, in the variables \code{coarsedemname}
 and \code{finedemname}. They contain `coarse' and `fine' data,
 respectively---that is, data sampled at widely spaced points over a
@@ -777,13 +777,13 @@
 common to both datasets. The name to be assigned to the resulting
 dataset is also derived from the name stored in the variable
-\code{combinedname} in the file \code{project.py}.
+\code{combinedname} in the file \file{project.py}.
 
 \subsection{Boundary Conditions}
 
 Setting boundaries follows a similar pattern to the one used for
-\code{bedslopephysical.py}, except that in this case we need to associate a
+\file{bedslopephysical.py}, except that in this case we need to associate a
 boundary type with each of the
 boundary tag names introduced when we established the mesh. In place of the four
-boundary types introduced for \code{bedslopephysical.py}, we use the reflective
+boundary types introduced for \file{bedslopephysical.py}, we use the reflective
 boundary for each of the
 eight tagged segments:
@@ -799,5 +799,5 @@
 
 With the basics established, the running of the `evolve' step is
-very similar to the corresponding step in \code{bedslopephysical.py}:
+very similar to the corresponding step in \file{bedslopephysical.py}:
 
 {\small \begin{verbatim}
@@ -840,13 +840,13 @@
 Each listing also describes the location of the module in which
 the code for the feature being described can be found. All modules
-are in the folder \code{inundation} or one of its subfolders, and the
-location of each module is described relative to \code{inundation}. Rather
+are in the folder \file{inundation} or one of its subfolders, and the
+location of each module is described relative to \file{inundation}. Rather
 than using pathnames, whose syntax depends on the operating system,
 we use the format adopted for importing the function or class for
 use in Python code. For example, suppose we wish to specify that the
-function \code{create\_mesh\_from\_regions} is in a module called
-\code{mesh\_interface} in a subfolder of \code{inundation} called
+function \function{create\_mesh\_from\_regions} is in a module called
+\module{mesh\_interface} in a subfolder of \module{inundation} called
 \code{pmesh}. In Linux or Unix syntax, the pathname of the file
-containing the function, relative to \code{inundation}, would be
+containing the function, relative to \file{inundation}, would be
 
 \begin{center}
@@ -936,5 +936,5 @@
 
 % Translate following into layman's language
-This method is used to add a region where the triagular mesh will not
+This method is used to add a region where the triangular mesh will not
 be generated to a Mesh instance.  The region is
 described by the polygon passed in.  Additionally,
@@ -950,7 +950,7 @@
 
 % Translate following into layman's language
-This method is used to generate the triagular mesh.  The  maximal area
+This method is used to generate the triangular mesh.  The  maximal area
 of any triangle in the mesh can be specified, along with the minimum
-angle of all triagles.
+angle of all triangles.
 \end{funcdesc}
 