Index: /documentation/user_manual/anuga_user_manual.tex
===================================================================
--- /documentation/user_manual/anuga_user_manual.tex	(revision 2726)
+++ /documentation/user_manual/anuga_user_manual.tex	(revision 2727)
@@ -1122,8 +1122,9 @@
                 verbose=False}
 This function returns a callable object representing an initial water
-displacement generated by a submarine sediment slide.
-
-The arguments include the downslope slide length, the water depth to the slide centre of mass,
-and the bathymetric slope.
+displacement generated by a submarine sediment failure. These failures can take the form of
+a submarine slump or slide.
+
+The arguments include as a minimum, the slump or slide length, the water depth to the centre of sediment 
+mass, and the bathymetric slope. Other slump or slide parameters can be included if they are known.
 \end{funcdesc}
 
@@ -1850,23 +1851,24 @@
     \item \indexedbold{\anuga} Name of software (joint development between ANU and GA)
 
-    \item \indexedbold{domain}
-
-    \item \indexedbold{Dirichlet boundary}
+    \item \indexedbold{domain} The domain of a function is the set of all input values to the function.
+
+    \item \indexedbold{Dirichlet boundary} - A Dirichlet boundary condition imposed on a differential equation
+ which specifies the values the solution is to take on the boundary of the domain.
 
     \item \indexedbold{elevation} - refers to bathymetry and topography
 
-    \item \indexedbold{bathymetry} offshore
-
-    \item \indexedbold{topography} onshore
-
-    \item \indexedbold{evolution} integration of the shallow water wave equations over time
+    \item \indexedbold{bathymetry} - offshore elevation
+
+    \item \indexedbold{topography} - onshore elevation
+
+    \item \indexedbold{evolution} - integration of the shallow water wave equations over time
 
     \item \indexedbold{forcing term}
 
-    \item \indexedbold{IDLE} Development environment shipped with Python
-
-    \item \indexedbold{Manning friction coefficient}
-
-    \item \indexedbold{mesh}    Triangulation of domain
+    \item \indexedbold{IDLE} - Development environment shipped with Python
+
+    \item \indexedbold{Manning friction coefficient} 
+
+    \item \indexedbold{mesh}    - Triangulation of domain
 
     \item \indexedbold{meshfile}  [generic word for either .tsh or
@@ -1876,5 +1878,5 @@
     .xya file]
 
-    \item \indexedbold{grid} evenly spaced
+    \item \indexedbold{grid} - evenly spaced mesh
 
     \item \indexedbold{NetCDF}
@@ -1884,5 +1886,5 @@
     \item \indexedbold{pyvolution} does this really need to be here? it's a class/module?
 
-    \item \indexedbold{conserved quantity} conserved (state, x and y momentum)
+    \item \indexedbold{conserved quantity} conserved (stage, x and y momentum)
 
     \item \indexedbold{reflective boundary}
@@ -1894,17 +1896,17 @@
 %    \item \indexedbold{try this}
 
-    \item \indexedbold{swollen} visualisation tool
-
-    \item \indexedbold{time boundary} defined in the manual (flog from there)
-
-    \item \indexedbold{transmissive boundary} defined in the manual (flog from there)
-
-    \item \indexedbold{xmomentum} conserved quantity (note, two-dimensional SWW equations say only x and y and NOT z)
-
-    \item \indexedbold{ymomentum}  conserved quantity
-
-    \item \indexedbold{resolution}   The maximal area of a triangular cell in a mesh
-
-    \item \indexedbold{polygon} A sequence of points in the plane. (Arbitrary polygons can be created
+    \item \indexedbold{swollen} - visualisation tool
+
+    \item \indexedbold{time boundary} - defined in the manual (flog from there)
+
+    \item \indexedbold{transmissive boundary} - defined in the manual (flog from there)
+
+    \item \indexedbold{xmomentum} - conserved quantity (note, two-dimensional SWW equations say only x and y and NOT z)
+
+    \item \indexedbold{ymomentum}  - conserved quantity
+
+    \item \indexedbold{resolution} -  The maximal area of a triangular cell in a mesh
+
+    \item \indexedbold{polygon} - A sequence of points in the plane. (Arbitrary polygons can be created
     in this way.)
     \anuga represents a polygon in one of two ways. One way is to represent it as a
@@ -1917,21 +1919,30 @@
     NOTE: More can be read in the module utilities/polygon.py ....
 
-    \item \indexedbold{easting}
-
-    \item \indexedbold{northing}
-
-    \item \indexedbold{latitude}
-
-    \item \indexedbold{longitude}
-
-    \item \indexedbold{edge}
-
-    \item \indexedbold{vertex}
-
-    \item \indexedbold{finite volume}
-
-    \item \indexedbold{flux}
-
-    \item \indexedbold{Digital Elevation Model (DEM)}
+    \item \indexedbold{easting} - A rectangular (x,y) coordinate measurement of distance east from a north-south reference line, 
+usually a meridian used as the axis of origin within a map zone or projection. Easting is a UTM (Universal Transverse Mercator) Coordinate.
+
+    \item \indexedbold{northing} - A rectangular (x,y) coordinate measurement of distance north from a north-south reference line, 
+usually a meridian used as the axis of origin within a map zone or projection. Northing is a UTM (Universal Transverse Mercator) Coordinate.
+
+
+    \item \indexedbold{latitude} - The angular distance on a mericlear north and south of the equator, expressed in degrees and minutes.
+
+    \item \indexedbold{longitude} - The angular distance east or west, between the meridian of a particular place on Earth and that of the 
+Prime Meridian (located in Greenwich, England) expressed in degrees or time.
+
+    \item \indexedbold{edge} - A triangulare cell within the computational mesh can be depicted as a set of vertices joined by lines (the edges).
+
+    \item \indexedbold{vertex} - A point at which edges meet. 
+
+    \item \indexedbold{finite volume} - The method evaluates the terms in the shallow water wave equationas fluxes at the surfaces of each 
+finite volume. Because the flux entering a given volume is identical to that leaving the adjacent volume, these methods are conservative. 
+Another advantage of the finite volume method is that it is easily formulated to allow for unstructured meshes. 
+The method is used in many computational fluid dynamics packages.
+
+
+    \item \indexedbold{flux} - the amount of flow through the volume per unit time 
+
+    \item \indexedbold{Digital Elevation Model (DEM)} - DEMs are digital files consisting of points of elevations, 
+sampled systematically at equally spaced intervals. 
 
 