Index: /inundation/report_generation/report_fesa_project_v1.tex
===================================================================
--- /inundation/report_generation/report_fesa_project_v1.tex	(revision 2748)
+++ /inundation/report_generation/report_fesa_project_v1.tex	(revision 2749)
@@ -23,5 +23,5 @@
 \textwidth \paperwidth 
 \advance\textwidth -2in
-\baselineskip 8pt
+%\baselineskip 10pt
 \title{Tsunami impact modelling for the North Welf shelf}
 \date{}
@@ -38,8 +38,10 @@
 
 \section{Introduction}
-
-This report is being provided to the Fire and Emergency Services Authority (FESA) 
+\label{sec:intro}
+
+This report is being provided to the Fire and Emergency Services Authority 
+(FESA) 
 as part of the Collaborative Research Agreement with Geoscience Australia. 
-The report describes the methods, assumptions and results of tsunami inundation 
+The report describes the methods, assumptions and results of tsunami inundation
 scenarios for two areas in the North West shelf region of the West Australian 
 coastline, namely Onslow and Pt Hedland. 
@@ -67,5 +69,6 @@
 \end{itemize}
 
-The inundation results for the two scenarios are described in section \ref{sec:results}.
+The inundation results for the two scenarios are described in section 
+\ref{sec:results}.
 
 \section{Data sources}
@@ -80,22 +83,31 @@
 these areas will affect the accuracy of the final model result.
 
-A number of sources have supplied data for these two studies. With respect to the 
-onshore data, the Defence Imagery and Geospatial Organisation (DIGO) supplied the 
-DTED (Digital Terrain Elevation Data) Level 2 data which
-has been authorised for Australian Tsunami Warning System use only. This data has a resolution of
-1 second (about 30 metres), produced from 1:50 000 contours, elevations and drainage.  
-The Department of Land Information (DLI) has provided a 20m DEM and orthophotography 
-covering the NW Shelf. This data set is not bare earth and as a result, we have 
-chosen to use the 30m DTED Level 2 data due to its bare earth thingo.
+A number of sources have supplied data for these two studies. With respect 
+to the 
+onshore data, the Defence Imagery and Geospatial Organisation (DIGO) 
+supplied the DTED (Digital Terrain Elevation Data) Level 2 data which
+has been authorised for Australian Tsunami Warning System use only. 
+This data has a resolution of
+1 second (about 30 metres), produced from 1:50 000 contours, elevations 
+and drainage.  
+The Department of Land Information (DLI) has provided a 20m DEM and 
+orthophotography 
+covering the NW Shelf. This data set is not bare earth and as a result, 
+we have chosen to use the 30m DTED Level 2 data due to its bare earth thingo.
  
-With respect to the offshore data, the Department of Planning and Infrastructure have provided
+With respect to the offshore data, the Department of Planning and 
+Infrastructure have provided
 state digital fairsheet data around Onslow. 
 This data covers only a very small geographic area. 
 (Note, similar data has also been provided for Broome.)
-The Port Hedland Port Authority has provided digital data from a multibeam survey of the 
-Port Hedland channel.  The Australian Hydrographic Office fairsheet data has also been utilised. 
-
-The coastline has been generated from the DIGO DTED2 and modified using the aerial photography and the two detailed 
-surveys provided by WA Department of Planning and Infrastructure. The extent of the data used
+The Port Hedland Port Authority has provided digital data from a multibeam 
+survey of the 
+Port Hedland channel.  The Australian Hydrographic Office fairsheet data 
+has also been utilised. 
+
+The coastline has been generated from the DIGO DTED2 and modified using the 
+aerial photography and the two detailed 
+surveys provided by WA Department of Planning and Infrastructure. 
+The extent of the data used
 for the tsunami impact modelling can be seen in the following two figures.
 
@@ -105,5 +117,5 @@
 
   \caption{Data extent for Onslow scenario}
-  \label{fig:onslow_area}
+  \label{fig:onslow_data_area}
 \end{figure}
 
@@ -113,19 +125,23 @@
 
   \caption{Data extent for Pt Hedland scenario}
-  \label{fig:pt_hedland_area}
-\end{figure}
-
+  \label{fig:pt_hedland_data_area}
+\end{figure}
+
+Section \ref{sec:metadata} outlines the metadata for data used for these
+studies.
 
 In summary,
 
 
-%\begin{tabular}{|l|l}} \hline
-%Data & Detail \hline
-%DIGO DTED Level 2 DIGO & Onshore, 1 second (\approx 30m) \hline
-%DLI & Onshore, 20m DEM and orthophotography \hline
-%DPI & Offshore, fairsheet data around Onslow \hline
-%Pt Hedland Port Authority & offshore, digital multibeam survey \hline
-%\end{tabular}
-
+\begin{center}
+\begin{tabular}{|l|l|}\hline
+Data & Detail \\ \hline
+DIGO DTED Level 2  & Onshore, 1 second ($\approx$ 30m) \\ \hline
+DLI & Onshore, 20m DEM and orthophotography \\ \hline
+DPI & Offshore, fairsheet data around Onslow \\ \hline
+Pt Hedland Port Authority \hspace{.3in} & Offshore, digital multibeam survey 
+\\ \hline
+\end{tabular}
+\end{center}
 
 What can we say about the data used here? How happy? Need to put in some words 
@@ -153,6 +169,8 @@
 \label{sec:results}
 
-To initiate the modelling, the computational mesh is constructed to cover the available data. 
-The resolution is chosen to balance computational time and desired resolution in areas of interest, 
+To initiate the modelling, the computational mesh is constructed to 
+cover the available data. 
+The resolution is chosen to balance computational time and desired 
+resolution in areas of interest, 
 particularly in the interface between the on and offshore.
 The following series of figures illustrate the study extent for the two
@@ -182,5 +200,5 @@
 
   \caption{Study area for scenario 2: Pt Hedland}
-  \label{fig:pthedland_area}
+  \label{fig:pt_hedland_area}
 \end{figure}
 
@@ -194,12 +212,16 @@
 \end{figure}
 
-%\input{interpretation}
+\input{interpretation}
 
 
 %\input{tex_output_test}
 
+
 \section{Summary}
 
 \section{References}
 
+\section{Metadata}
+\label{sec:metadata}
+\input{metadata.tex}
 \end{document}