Index: /production/onslow_2006/latex_output_20060424_020426_duplictate_time_steps.tex
===================================================================
--- /production/onslow_2006/latex_output_20060424_020426_duplictate_time_steps.tex	(revision 2821)
+++ /production/onslow_2006/latex_output_20060424_020426_duplictate_time_steps.tex	(revision 2822)
@@ -9,5 +9,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__First_stage_20060424_020426_duplictate_time_steps}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_stage_20060424_020426_duplictate_time_steps.png}} 
 \caption{Time series for stage} 
  \label{fig:20060424_020426_duplictate_time_steps_stage_gauge__First} 
@@ -15,5 +15,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__First_velocity_20060424_020426_duplictate_time_steps}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_velocity_20060424_020426_duplictate_time_steps.png}} 
 \caption{Time series for velocity} 
  \label{fig:20060424_020426_duplictate_time_steps_velocity_gauge__First} 
@@ -21,5 +21,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__First_bearing_20060424_020426_duplictate_time_steps}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_bearing_20060424_020426_duplictate_time_steps.png}} 
 \caption{Time series for bearing} 
  \label{fig:20060424_020426_duplictate_time_steps_bearing_gauge__First} 
@@ -27,5 +27,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Second_stage_20060424_020426_duplictate_time_steps}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_stage_20060424_020426_duplictate_time_steps.png}} 
 \caption{Time series for stage} 
  \label{fig:20060424_020426_duplictate_time_steps_stage_gauge__Second} 
@@ -33,5 +33,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Second_velocity_20060424_020426_duplictate_time_steps}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_velocity_20060424_020426_duplictate_time_steps.png}} 
 \caption{Time series for velocity} 
  \label{fig:20060424_020426_duplictate_time_steps_velocity_gauge__Second} 
@@ -39,5 +39,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Second_bearing_20060424_020426_duplictate_time_steps}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_bearing_20060424_020426_duplictate_time_steps.png}} 
 \caption{Time series for bearing} 
  \label{fig:20060424_020426_duplictate_time_steps_bearing_gauge__Second} 
@@ -45,5 +45,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Deep_stage_20060424_020426_duplictate_time_steps}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_stage_20060424_020426_duplictate_time_steps.png}} 
 \caption{Time series for stage} 
  \label{fig:20060424_020426_duplictate_time_steps_stage_gauge__Deep} 
@@ -51,5 +51,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Deep_velocity_20060424_020426_duplictate_time_steps}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_velocity_20060424_020426_duplictate_time_steps.png}} 
 \caption{Time series for velocity} 
  \label{fig:20060424_020426_duplictate_time_steps_velocity_gauge__Deep} 
@@ -57,5 +57,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Deep_bearing_20060424_020426_duplictate_time_steps}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_bearing_20060424_020426_duplictate_time_steps.png}} 
 \caption{Time series for bearing} 
  \label{fig:20060424_020426_duplictate_time_steps_bearing_gauge__Deep} 
Index: /production/onslow_2006/latex_output_20060426_004129.tex
===================================================================
--- /production/onslow_2006/latex_output_20060426_004129.tex	(revision 2821)
+++ /production/onslow_2006/latex_output_20060426_004129.tex	(revision 2822)
@@ -9,5 +9,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__First_stage_20060426_004129}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_stage_20060426_004129.png}} 
 \caption{Time series for stage} 
  \label{fig:20060426_004129_stage_gauge__First} 
@@ -15,5 +15,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__First_velocity_20060426_004129}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_velocity_20060426_004129.png}} 
 \caption{Time series for velocity} 
  \label{fig:20060426_004129_velocity_gauge__First} 
@@ -21,5 +21,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__First_bearing_20060426_004129}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_bearing_20060426_004129.png}} 
 \caption{Time series for bearing} 
  \label{fig:20060426_004129_bearing_gauge__First} 
@@ -27,5 +27,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Second_stage_20060426_004129}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_stage_20060426_004129.png}} 
 \caption{Time series for stage} 
  \label{fig:20060426_004129_stage_gauge__Second} 
@@ -33,5 +33,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Second_velocity_20060426_004129}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_velocity_20060426_004129.png}} 
 \caption{Time series for velocity} 
  \label{fig:20060426_004129_velocity_gauge__Second} 
@@ -39,5 +39,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Second_bearing_20060426_004129}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_bearing_20060426_004129.png}} 
 \caption{Time series for bearing} 
  \label{fig:20060426_004129_bearing_gauge__Second} 
@@ -45,5 +45,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Deep_stage_20060426_004129}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_stage_20060426_004129.png}} 
 \caption{Time series for stage} 
  \label{fig:20060426_004129_stage_gauge__Deep} 
@@ -51,5 +51,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Deep_velocity_20060426_004129}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_velocity_20060426_004129.png}} 
 \caption{Time series for velocity} 
  \label{fig:20060426_004129_velocity_gauge__Deep} 
@@ -57,5 +57,5 @@
  
 \begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{Z:/inundation/sandpits/jsexton/ANUGA/production/onslow_2006/report_figures/gauge__Deep_bearing_20060426_004129}} 
+ \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_bearing_20060426_004129.png}} 
 \caption{Time series for bearing} 
  \label{fig:20060426_004129_bearing_gauge__Deep} 