Index: oduction/onslow_2006/latex_output_20060424_020426_duplictate_time_steps.tex
===================================================================
--- /production/onslow_2006/latex_output_20060424_020426_duplictate_time_steps.tex	(revision 2827)
+++ 	(revision )
@@ -1,63 +1,0 @@
-\begin{center} 
- \begin{tabular}{|l|l|l|}\hline 
- \bf{Gauge Name} & \bf{Easting} & \bf{Northing} \\ \hline 
- First & 310000.00 & 7620000.00 \\ \hline 
- Second & 305000.00 & 7625000.00 \\ \hline 
- Deep & 280000.00 & 7690000.00 \\ \hline 
-\end{tabular} 
- \end{center} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_stage_20060424_020426_duplictate_time_steps.png}} 
-\caption{Time series for stage} 
- \label{fig:20060424_020426_duplictate_time_steps_stage_gauge__First} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_velocity_20060424_020426_duplictate_time_steps.png}} 
-\caption{Time series for velocity} 
- \label{fig:20060424_020426_duplictate_time_steps_velocity_gauge__First} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_bearing_20060424_020426_duplictate_time_steps.png}} 
-\caption{Time series for bearing} 
- \label{fig:20060424_020426_duplictate_time_steps_bearing_gauge__First} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_stage_20060424_020426_duplictate_time_steps.png}} 
-\caption{Time series for stage} 
- \label{fig:20060424_020426_duplictate_time_steps_stage_gauge__Second} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_velocity_20060424_020426_duplictate_time_steps.png}} 
-\caption{Time series for velocity} 
- \label{fig:20060424_020426_duplictate_time_steps_velocity_gauge__Second} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_bearing_20060424_020426_duplictate_time_steps.png}} 
-\caption{Time series for bearing} 
- \label{fig:20060424_020426_duplictate_time_steps_bearing_gauge__Second} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_stage_20060424_020426_duplictate_time_steps.png}} 
-\caption{Time series for stage} 
- \label{fig:20060424_020426_duplictate_time_steps_stage_gauge__Deep} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_velocity_20060424_020426_duplictate_time_steps.png}} 
-\caption{Time series for velocity} 
- \label{fig:20060424_020426_duplictate_time_steps_velocity_gauge__Deep} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_bearing_20060424_020426_duplictate_time_steps.png}} 
-\caption{Time series for bearing} 
- \label{fig:20060424_020426_duplictate_time_steps_bearing_gauge__Deep} 
- \end{figure} 
- 
Index: oduction/onslow_2006/latex_output_20060426_004129.tex
===================================================================
--- /production/onslow_2006/latex_output_20060426_004129.tex	(revision 2827)
+++ 	(revision )
@@ -1,63 +1,0 @@
-\begin{center} 
- \begin{tabular}{|l|l|l|}\hline 
- \bf{Gauge Name} & \bf{Easting} & \bf{Northing} \\ \hline 
- First & 310000.00 & 7620000.00 \\ \hline 
- Second & 305000.00 & 7625000.00 \\ \hline 
- Deep & 280000.00 & 7690000.00 \\ \hline 
-\end{tabular} 
- \end{center} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_stage_20060426_004129.png}} 
-\caption{Time series for stage} 
- \label{fig:20060426_004129_stage_gauge__First} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_velocity_20060426_004129.png}} 
-\caption{Time series for velocity} 
- \label{fig:20060426_004129_velocity_gauge__First} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__First_bearing_20060426_004129.png}} 
-\caption{Time series for bearing} 
- \label{fig:20060426_004129_bearing_gauge__First} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_stage_20060426_004129.png}} 
-\caption{Time series for stage} 
- \label{fig:20060426_004129_stage_gauge__Second} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_velocity_20060426_004129.png}} 
-\caption{Time series for velocity} 
- \label{fig:20060426_004129_velocity_gauge__Second} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Second_bearing_20060426_004129.png}} 
-\caption{Time series for bearing} 
- \label{fig:20060426_004129_bearing_gauge__Second} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_stage_20060426_004129.png}} 
-\caption{Time series for stage} 
- \label{fig:20060426_004129_stage_gauge__Deep} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_velocity_20060426_004129.png}} 
-\caption{Time series for velocity} 
- \label{fig:20060426_004129_velocity_gauge__Deep} 
- \end{figure} 
- 
-\begin{figure}[hbt] 
- \centerline{\includegraphics[width=75mm, height=75mm]{~/anuga/production/onslow_2006/gauge__Deep_bearing_20060426_004129.png}} 
-\caption{Time series for bearing} 
- \label{fig:20060426_004129_bearing_gauge__Deep} 
- \end{figure} 
- 
Index: /production/onslow_2006/make_report.py
===================================================================
--- /production/onslow_2006/make_report.py	(revision 2827)
+++ /production/onslow_2006/make_report.py	(revision 2828)
@@ -140,5 +140,5 @@
 \section{Metadata} \n \
 \label{sec:metadata} \n \
-\input{metadata.tex} \n \
+\input{metadata} \n \
 \end{document}'
 fid.write(s)